]> arthur.barton.de Git - bup.git/blobdiff - Makefile
test-web: mark as unresolved with respect to python 3
[bup.git] / Makefile
index a185bac979dd6d00d749d26328e4b12a4e3483c8..8b062a4445ca5e322f7fd6ff5e15c13803648ce6 100644 (file)
--- a/Makefile
+++ b/Makefile
@@ -46,23 +46,23 @@ config/config.vars: configure config/configure config/configure.inc \
   $(wildcard config/*.in)
        MAKE="$(MAKE)" ./configure
 
-bup_cmds := cmd/bup-python\
+bup_cmds := cmd/bup-python \
   $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
   $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))
 
-bup_deps := bup lib/bup/_checkout.py lib/bup/_helpers$(SOEXT) $(bup_cmds)
+bup_deps := lib/bup/_checkout.py lib/bup/_helpers$(SOEXT) $(bup_cmds)
 
 all: $(bup_deps) Documentation/all $(current_sampledata)
 
-bup:
-       ln -s main.py bup
-
 $(current_sampledata):
        t/configure-sampledata --setup
 
-define install-python-bin
+
+bup_libdir="$script_home/../lib"  # bup_libdir will be adjusted during install
+
+define install-bup-python
   set -e; \
-  sed -e '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
+  sed -e 's|.*# bup_libdir will be adjusted during install|bup_libdir="$$script_home/.."|' $1 > $2; \
   chmod 0755 $2;
 endef
 
@@ -98,11 +98,12 @@ install: all
        test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(dest_mandir)/man1
        test -z "$(man_html)" || install -d $(dest_docdir)
        test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(dest_docdir)
-       $(call install-python-bin,bup,"$(dest_bindir)/bup")
+       $(INSTALL) -pm 0755 cmd/bup $(dest_libdir)/cmd/
+       $(INSTALL) -pm 0755 cmd/bup-* $(dest_libdir)/cmd/
+       $(call install-bup-python,cmd/bup-python,"$(dest_libdir)/cmd/bup-python")
+       cd "$(dest_bindir)" && \
+         ln -sf "$$($(bup_python) -c 'import os; print(os.path.relpath("$(abspath $(dest_libdir))/cmd/bup"))')"
        set -e; \
-       for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
-         $(call install-python-bin,"$$cmd","$(dest_libdir)/$$cmd") \
-       done
        $(INSTALL) -pm 0644 \
                lib/bup/*.py \
                $(dest_libdir)/bup
@@ -125,8 +126,8 @@ lib/bup/_helpers$(SOEXT): \
        cd lib/bup && \
        LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" "$(bup_python)" csetup.py build
         # Make sure there's just the one file we expect before we copy it.
-       find lib/bup/build/* -maxdepth 1 -name '_helpers*$(SOEXT)' \
-         -exec printf 'x' '{}' \; | wc -c | xargs test 1 -eq
+       "$(bup_python)" -c \
+         "import glob; assert(len(glob.glob('lib/bup/build/*/_helpers*$(SOEXT)')) == 1)"
        cp lib/bup/build/*/_helpers*$(SOEXT) "$@"
 
 lib/bup/_checkout.py:
@@ -142,52 +143,88 @@ t/tmp:
 
 runtests: runtests-python runtests-cmdline
 
+python_tests := \
+  lib/bup/t/tbloom.py \
+  lib/bup/t/tclient.py \
+  lib/bup/t/tgit.py \
+  lib/bup/t/thashsplit.py \
+  lib/bup/t/thelpers.py \
+  lib/bup/t/tindex.py \
+  lib/bup/t/tmetadata.py \
+  lib/bup/t/toptions.py \
+  lib/bup/t/tresolve.py \
+  lib/bup/t/tshquote.py \
+  lib/bup/t/tvfs.py \
+  lib/bup/t/tvint.py \
+  lib/bup/t/txstat.py
+
 # The "pwd -P" here may not be appropriate in the long run, but we
 # need it until we settle the relevant drecurse/exclusion questions:
 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
 runtests-python: all t/tmp
+       mkdir -p t/tmp/test-log
        $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
-         "$(bup_python)" wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
+         ./wvtest.py  $(python_tests) 2>&1 \
            | tee -a t/tmp/test-log/$$$$.log
 
 cmdline_tests := \
-  t/test-ftp \
-  t/test-save-restore \
-  t/test-packsizelimit \
-  t/test-prune-older \
-  t/test-web.sh \
-  t/test-rm.sh \
-  t/test-gc.sh \
-  t/test-main.sh \
-  t/test-list-idx.sh \
-  t/test-index.sh \
-  t/test-split-join.sh \
-  t/test-fuse.sh \
-  t/test-drecurse.sh \
+  t/test.sh \
+  t/test-argv \
   t/test-cat-file.sh \
+  t/test-command-without-init-fails.sh \
   t/test-compression.sh \
+  t/test-drecurse.sh \
   t/test-fsck.sh \
-  t/test-index-clear.sh \
+  t/test-fuse.sh \
+  t/test-ftp \
+  t/test-gc.sh \
+  t/test-import-duplicity.sh \
+  t/test-import-rdiff-backup.sh \
+  t/test-index.sh \
   t/test-index-check-device.sh \
+  t/test-index-clear.sh \
+  t/test-list-idx.sh \
   t/test-ls \
   t/test-ls-remote \
-  t/test-tz.sh \
+  t/test-main.sh \
   t/test-meta.sh \
   t/test-on.sh \
+  t/test-packsizelimit \
+  t/test-prune-older \
+  t/test-redundant-saves.sh \
   t/test-restore-map-owner.sh \
   t/test-restore-single-file.sh \
+  t/test-rm.sh \
   t/test-rm-between-index-and-save.sh \
-  t/test-save-with-valid-parent.sh \
-  t/test-sparse-files.sh \
-  t/test-command-without-init-fails.sh \
-  t/test-redundant-saves.sh \
   t/test-save-creates-no-unrefs.sh \
+  t/test-save-restore \
   t/test-save-restore-excludes.sh \
   t/test-save-strip-graft.sh \
-  t/test-import-duplicity.sh \
-  t/test-import-rdiff-backup.sh \
-  t/test-xdev.sh \
-  t/test.sh
+  t/test-save-with-valid-parent.sh \
+  t/test-sparse-files.sh \
+  t/test-split-join.sh \
+  t/test-tz.sh \
+  t/test-xdev.sh
+
+ifeq "2" "$(bup_python_majver)"
+  # unresolved
+  #   web: needs more careful attention, path bytes round-trips, reprs, etc.
+  cmdline_tests += \
+    t/test-web.sh
+endif
+
+tmp-target-run-test-get-%: all t/tmp
+       $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
+         t/test-get $* 2>&1 | tee -a t/tmp/test-log/$$$$.log
+
+test_get_targets += \
+  tmp-target-run-test-get-replace \
+  tmp-target-run-test-get-universal \
+  tmp-target-run-test-get-ff \
+  tmp-target-run-test-get-append \
+  tmp-target-run-test-get-pick \
+  tmp-target-run-test-get-new-tag \
+  tmp-target-run-test-get-unnamed
 
 # For parallel runs.
 # The "pwd -P" here may not be appropriate in the long run, but we
@@ -197,7 +234,7 @@ tmp-target-run-test%: all t/tmp
        $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
          t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
 
-runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))
+runtests-cmdline: $(test_get_targets) $(subst t/test,tmp-target-run-test,$(cmdline_tests))
 
 stupid:
        PATH=/bin:/usr/bin $(MAKE) test
@@ -206,7 +243,7 @@ test: all
        if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
        mkdir -p t/tmp/test-log
        ./wvtest watch --no-counts \
-         $(MAKE) runtests-python runtests-cmdline 2>t/tmp/test-log/$$$$.log
+         $(MAKE) runtests 2>t/tmp/test-log/$$$$.log
        ./wvtest report t/tmp/test-log/*.log
 
 check: test
@@ -214,11 +251,25 @@ check: test
 distcheck: all
        ./wvtest run t/test-release-archive.sh
 
-cmd/python-cmd.sh: config/config.vars Makefile
-       printf "#!/bin/sh\nexec %q \"\$$@\"" "$(bup_python)" \
-         >> cmd/python-cmd.sh.$$PPID.tmp
-       chmod +x cmd/python-cmd.sh.$$PPID.tmp
-       mv cmd/python-cmd.sh.$$PPID.tmp cmd/python-cmd.sh
+cmd/bup-python: cmd/python-cmd.sh config/config.var/bup-python
+       "$$(cat config/config.var/bup-python)" dev/replace -l '@bup_python@' \
+         "$$(dev/shquote < config/config.var/bup-python)" \
+         < "$<" > "$@".$$PPID.tmp
+       chmod +x "$@".$$PPID.tmp
+       mv "$@".$$PPID.tmp "$@"
+
+long-test: export BUP_TEST_LEVEL=11
+long-test: test
+
+long-check: export BUP_TEST_LEVEL=11
+long-check: check
+
+.PHONY: check-both
+check-both:
+       $(MAKE) clean \
+         && PYTHON=python3 BUP_ALLOW_UNEXPECTED_PYTHON_VERSION=true $(MAKE) check
+       $(MAKE) clean \
+         && PYTHON=python2 $(MAKE) check
 
 cmd/bup-%: cmd/%-cmd.py
        rm -f $@
@@ -247,25 +298,12 @@ Documentation/%.html: Documentation/%.md Documentation/substvars
 Documentation/clean:
        cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars
 
-# update the local 'man' and 'html' branches with pregenerated output files, for
-# people who don't have pandoc (and maybe to aid in google searches or something)
-export-docs: Documentation/all
-       git update-ref refs/heads/man origin/man '' 2>/dev/null || true
-       git update-ref refs/heads/html origin/html '' 2>/dev/null || true
-       set -eo pipefail; \
-       GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
-       rm -f $${GIT_INDEX_FILE} && \
-       git add -f Documentation/*.1 && \
-       git update-ref refs/heads/man \
-               $$(echo "Autogenerated man pages for $$(git describe --always)" \
-                   | git commit-tree $$(git write-tree --prefix=Documentation) \
-                               -p refs/heads/man) && \
-       rm -f $${GIT_INDEX_FILE} && \
-       git add -f Documentation/*.html && \
-       git update-ref refs/heads/html \
-               $$(echo "Autogenerated html pages for $$(git describe --always)" \
-                   | git commit-tree $$(git write-tree --prefix=Documentation) \
-                               -p refs/heads/html)
+# Note: this adds commits containing the current manpages in roff and
+# html format to the man and html branches respectively.  The version
+# is determined by "git describe --always".
+.PHONY: update-doc-branches
+update-doc-branches: Documentation/all
+       dev/update-doc-branches refs/heads/man refs/heads/html
 
 # push the pregenerated doc files to origin/man and origin/html
 push-docs: export-docs
@@ -280,12 +318,15 @@ import-docs: Documentation/clean
 clean: Documentation/clean cmd/bup-python
        cd config && rm -f *~ .*~ \
          ${CONFIGURE_DETRITUS} ${CONFIGURE_FILES} ${GENERATED_FILES}
+       cd config && rm -rf config.var
        rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
                .*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
                *.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
-               bup bup-* \
                randomgen memtest \
                testfs.img lib/bup/t/testfs.img
+       for x in $$(ls cmd/*-cmd.py cmd/*-cmd.sh | grep -vF python-cmd.sh | cut -b 5-); do \
+           echo "cmd/bup-$${x%-cmd.*}"; \
+       done | xargs -t rm -f
        if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
        if test -e t/mnt; then rm -r t/mnt; fi
        if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
@@ -297,4 +338,4 @@ clean: Documentation/clean cmd/bup-python
        ./configure-version --clean
        t/configure-sampledata --clean
         # Remove last so that cleanup tools can depend on it
-       rm -f cmd/bup-* cmd/python-cmd.sh
+       rm -f cmd/bup-python